<script setup lang="ts">
import type { IBExperiment } from "~/utils/types/ibeetle";
import type { Phenotype } from "~/utils/types/phenotype";
import { IBEETLE_TOPICS } from "~/utils/types/ibeetle";

const props = defineProps<{
  phenotypes: Phenotype[];
  experiment: IBExperiment;
}>();

const topics = [
  ...IBEETLE_TOPICS.filter((t) => t.experimentId === props.experiment.id),
  { id: "_no_id", name: "Other" },
];

const phenotypesByTopic: Record<string, Phenotype[]> = {};
topics.forEach((topic) => {
  phenotypesByTopic[topic.id] = [];
});

(props.phenotypes || []).forEach((o) => {
  if (!o.iBeetleTopic) {
    phenotypesByTopic._no_id.push(o);
  } else {
    phenotypesByTopic[o.iBeetleTopic].push(o);
  }
});

const topicsWithData = topics.filter((t) => phenotypesByTopic[t.id].length > 0);
</script>

<template>
  <ExpansionPanel>
    <template #title>
      <span class="text-h6 font-weight-regular">
        {{ props.experiment.displayName }}
      </span>
    </template>

    <template
      v-for="topic in topicsWithData"
      :key="`${props.experiment.id}-${topic.id}`"
    >
      <ExpansionPanel>
        <template #title>
          <span class="text-overline">
            {{ topic.name }}
          </span>
        </template>
        <PhenotypeItem
          v-for="p in phenotypesByTopic[topic.id].sort(
            (a, b) => (a.dayPostInjection || -1) - (b.dayPostInjection || -1),
          )"
          :key="p.id"
          variant="normal"
          :phenotype="p"
        />
      </ExpansionPanel>
    </template>
  </ExpansionPanel>
</template>

<style scoped>
:deep(.v-expansion-panel-header) {
  width: initial;
  min-height: 0;
  padding: 0;
}
</style>
